EnableExplicit

Define PBEx_WMI

CompilerIf #PB_Compiler_Processor = #PB_Processor_x86
  PBEx_WMI = OpenLibrary(#PB_Any, "PB.Ex_WMI_x86.dll")
CompilerElseIf #PB_Compiler_Processor = #PB_Processor_x64
  PBEx_WMI = OpenLibrary(#PB_Any, "PB.Ex_WMI_x64.dll")
CompilerEndIf

If PBEx_WMI
  Prototype ExecuteWMIQuery(Namespace.p-Unicode, Query.p-Unicode, Output)
  Define ExecuteWMIQuery.ExecuteWMIQuery = GetFunction(PBEx_WMI, "ExecuteWMIQuery")
  Prototype ExecuteWMIMethod(Namespace.p-Unicode, Query.p-Unicode, Method.p-Unicode, ParameterArray, ParameterArraySize)
  Define ExecuteWMIMethod.ExecuteWMIMethod = GetFunction(PBEx_WMI, "ExecuteWMIMethod")
  Prototype WaitWMIEvent(Query.p-Unicode, Timeout = 0)
  Define WaitWMIEvent.WaitWMIEvent = GetFunction(PBEx_WMI, "WaitWMIEvent")
  
  Define Output$ = Space(1000000)
  ExecuteWMIQuery("root\CIMV2", "SELECT * FROM Win32_LogicalDisk", @Output$)
  ParseXML(1, Output$)
  FormatXML(1, #PB_XML_WindowsNewline | #PB_XML_ReFormat | #PB_XML_ReIndent)
  Debug ComposeXML(1)
  
;   Dim ParameterArray.s(0)
;   ParameterArray(0) = "Name=YourNewUsername"
;   Debug ExecuteWMIMethod("root\CIMV2", "Win32_UserAccount.Domain='YourWorkgroup',Name='YourUsername'", "Rename", ParameterArray(), ArraySize(ParameterArray())+1)
;   
;   ;Administratorrechte erforderlich
;   Debug "Warten, bis der Taschenrechner gestartet wurde..."
;   If WaitWMIEvent("SELECT * FROM Win32_ProcessStartTrace WHERE ProcessName = 'calc.exe'") = 0
;     Debug "Taschenrechner wurde gestartet."
;   Else
;     Debug "Fehler"
;   EndIf
  
  CloseLibrary(PBEx_WMI)
EndIf